/**************************************************************************
**
** Copyright (C) Computer Science Department, Worcester Polytechnic Institute,
**                           All rights reserved.
**
** FILE NAME: CFtpSave.h
**
** DESCRIPTION: This class sends the statistics to a specified server via FTP
**              
**
** AUTHOR: Zheng Zuo/Yubing Wang        March-2001
**
/**************************************************************************/


// FtpSave.h: interface for the CFtpSave class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_FTPSAVE_H__F3AE2C46_21E6_4D4F_A854_BABC6AD61BDF__INCLUDED_)
#define AFX_FTPSAVE_H__F3AE2C46_21E6_4D4F_A854_BABC6AD61BDF__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <afxinet.h>

class CFtpSave  
{
private:
    CInternetSession *m_pInetSession;
    CFtpConnection *m_pFtpConnection;
    CInternetFile *m_pInternetFile;

public:
	CFtpSave();
	CFtpSave(LPCTSTR pstrServer, LPCTSTR pstrUserName = NULL, LPCTSTR pstrPassword = NULL);
	virtual ~CFtpSave();

    void Connect(LPCTSTR pstrServer, LPCTSTR pstrUserName = NULL, LPCTSTR pstrPassword = NULL);
    void CloseConnection();
    BOOL bConnected();
    void Makedir(LPCTSTR pstrDirName);
    void OpenFile(LPCTSTR pstrFileName);
    void Write(const void *lpBuf, UINT nCount);
    void WriteString(LPCTSTR pstr);
    void CloseFile();
    BOOL bFileOpened();
};

#endif // !defined(AFX_FTPSAVE_H__F3AE2C46_21E6_4D4F_A854_BABC6AD61BDF__INCLUDED_)
