/**************************************************************************
**
** Copyright (C) Computer Science Department, Worcester Polytechnic Institute,
**                           All rights reserved.
**
** FILE NAME: RMAContext.cpp
**
** DESCRIPTION: This program implements the methods of CRMAContext class
**              
**
** AUTHOR: Zheng Zuo/Yubing Wang       March-2001
**
/**************************************************************************/


// RMAContext.cpp: implementation of the CRMAContext class.
//
//////////////////////////////////////////////////////////////////////
/****************************************************************************
 /* Defines
 */
//#define INITGUID     /* Interface ID's */

/****************************************************************************
 * Includes
 */
#ifdef _UNIX
  #include <stdlib.h> // for getenv()
#endif

#include "pntypes.h"
#include "pnwintyp.h"

#include "stdafx.h"
#include "pncom.h"
#include "rmapckts.h"
#include "rmacomm.h"
#include "rmamon.h"
#include "rmafiles.h"
#include "rmaengin.h"
#include "rmacore.h"
#include "rmargn.h"
#include "rmaclsnk.h"
#include "rmaerror.h"
#include "rmaauth.h"
#include "rmawin.h"

#include "rmasite2.h"
#include "rmavsurf.h"

#include "os.h"
#include "fivemmap.h"
#include "exadvsnk.h"
#include "exerror.h"
#include "exsitsup.h"
#include "exaumgr.h"
#include "excontxt.h"
#include "fivemlist.h"
#include "rmaupgrd.h"
#include "exnwsite.h"
#include "exvsurf.h"
#include "rmargn.h"
#include "rmarendr.h"



#include "RealTracker.h"
#include "RMAContext.h"
#include "testframe.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

/****************************************************************************
 * Globals
 */
HWND topWnd; 
//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////
CRMAContext::CRMAContext()
{
    m_VQTest = NULL;
    testPlay = NULL;
}

CRMAContext::CRMAContext(CVQTest *pVQTest)
{
    m_VQTest = pVQTest;
	testPlay = new TestFrame(m_VQTest);
	topWnd=(HWND)pVQTest->GetRealTrackerView()->GetSafeHwnd();
}

CRMAContext::~CRMAContext()
{
//    if (m_VQTest != NULL)
//        delete m_VQTest;
	if(testPlay != NULL)
	{
//		testPlay->cleanup();
        delete testPlay;
		testPlay = NULL;
	}
}

void CRMAContext::Play(char *URL)
{
	if(testPlay != NULL && testPlay->pPlayer != NULL)
	{
		if(testPlay->pPlayer->IsDone())
			testPlay->play_stream(URL);
		else
			testPlay->pPlayer->Begin();
	}
	else
	{
		testPlay = new TestFrame(m_VQTest);
		testPlay->play_stream(URL);
	}
}
void CRMAContext::Pause()
{
	if(testPlay != NULL && testPlay->pPlayer != NULL)
		testPlay->pPlayer->Pause();
}
void CRMAContext::Stop()
{
	if(testPlay != NULL && testPlay->pPlayer != NULL)
		testPlay->pPlayer->Stop();
}
void CRMAContext::ReSize(double SizeRatio)
{
	if(testPlay != NULL)
		testPlay->setWindowSize(SizeRatio);
}
