/**************************************************************************
**
** Copyright (C) Computer Science Department, Worcester Polytechnic Institute,
**                           All rights reserved.
**
** FILE NAME: RMAContext.h
**
** DESCRIPTION: This class defines RealVideo playback control that in turn calls
**              the RealSystem SDK functions.
**              
**
** AUTHOR: Zheng Zuo/Yubing Wang        March-2001
**
/**************************************************************************/


// RMAContext.h: interface for the CRMAContext class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_RMACONTEXT_H__2B23944D_B903_4439_8EBE_368816AE6293__INCLUDED_)
#define AFX_RMACONTEXT_H__2B23944D_B903_4439_8EBE_368816AE6293__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "VQTest.h"
#include "VQData.h"


class CVQTest;
class TestFrame;

class CRMAContext : public CObject
{
private:
    CVQTest *m_VQTest;
	TestFrame *testPlay;
public:
	CRMAContext();
	CRMAContext(CVQTest *pVQTest);
	virtual ~CRMAContext();

    void Play(char *URL);
    void Pause();
    void Stop();
    void ReSize(double SizeRatio);
};

#endif // !defined(AFX_RMACONTEXT_H__2B23944D_B903_4439_8EBE_368816AE6293__INCLUDED_)
