// VQData.h
//
//////////////////////////////////////////////////////////////////////

#if !defined(_VQDATA_H_)
#define _VQDATA_H_

#define WM_VQACTION             WM_USER + 1234

#define CVQ_DATA_ON_BUFFER		5000
#define CVQ_DATA_ON_OPEN		5001
#define CVQ_DATA_ON_CLOSE		5002
#define CVQ_DATA_ON_STATISTICS  5003
#define CVQ_DATA_ON_PRESEEK		5004
#define CVQ_DATA_ON_POSTSEEK	5005
#define CVQ_DATA_ON_POSITION	5006
#define CVQ_DATA_ON_STOP		5007
#define CVQ_DATA_ON_PAUSE		5008
#define CVQ_DATA_ON_BEGIN		5009
#define CVQ_DATA_ON_CONTACT		5010
#define CVQ_DATA_ON_MINUTE		5011
#define CVQ_DATA_ON_SECOND		5011

  
struct VQData
{
    char *Name;
    int CodedBandWidth;
    int AverageBandWidth;
    int TotalBandWidth;
    int CurrentBandWidth;
    int AverageLatency;
    int TransportMode;         // 1:TCP 2:UDP 3:RTSPvHTTP 4:HTTP 5:Unknown
    double CodedFrameRate;
    double AverageFrameRate;
    double CurrentFrameRate;
    int FramesDropped;
    int FramesLost;
    double AverageJitter;
    double CurrentJitter;
    double MaxJitter;
    double CpuUsage;
    int playTime;
    int totalTime;
    char *VideoCodecName;
    char *ServerInfo;

    int NumOfPeriod;
//    double intervals[500];
};

struct VQDataLink
{
    VQData data;
    VQDataLink *next;
};

struct VQJitter
{
    double AverageJitter;
    double CurrentJitter;
};

struct VQJitterLink
{
    VQJitter data;
    VQJitterLink *next;
};

struct VQRawData
{
	int num_one_second;
	int num_one_minute;
	int num_total;
	double sqr_one_second;
	double sqr_one_minute;
	double sqr_total;
	double sum_one_second;
	double sum_one_minute;
	double sum_total;
//    double intervals[500];
};

#endif // !defined(_VQDATA_H_)
