/****************************************************************************
 * 
 *  $Id: exadvsnk.cpp,v 1.2 2000/05/19 22:57:11 ahamel Exp $
 *
 *  Copyright (C) 1995,1996,1997 RealNetworks, Inc.
 *  All rights reserved.
 *
 *  http://www.real.com/devzone
 *
 *  This program contains proprietary information of RealNetworks, Inc.,
 *  and is licensed subject to restrictions on use and distribution.
 * 
 *  exadvsnk.cpp
 *
 *  Sample Implementation of Client Advise Sink Interfaces
 *
 */


/****************************************************************************
 * Includes
 */
#include "pntypes.h"
#include "pncom.h"
#include "rmacomm.h"
#include "rmamon.h"
#include "rmacore.h"
#include "rmapckts.h"

#include "os.h"
#include "rmaclsnk.h"
#include "rmawin.h"
#include "pnwintyp.h"
#include "fivemmap.h"
#include "fivemlist.h"
#include "exadvsnk.h"
#include "VQData.h"
#include "math.h"

#include "..\SysStatus.h"

/****************************************************************************
 * Globals
 */
extern HWND topWnd;
extern VQRawData m_RawData;
/****************************************************************************
 *  ExampleClientAdviceSink::ExampleClientAdviceSink         ref:  exadvsnk.h
 *
 *  Constructor
 */
ExampleClientAdviceSink::ExampleClientAdviceSink(IUnknown* pUnknown)
    : m_lRefCount (0)
    , m_pUnknown (NULL)
    , m_pRegistry (NULL)
{
    if (pUnknown)
    {
	m_pUnknown = pUnknown;
	m_pUnknown->AddRef();

	if (PNR_OK != m_pUnknown->QueryInterface(IID_IRMAPNRegistry, (void**)&m_pRegistry))
	{
	    m_pRegistry = NULL;
	}

	IRMAPlayer* pPlayer;
	if(PNR_OK == m_pUnknown->QueryInterface(IID_IRMAPlayer,
						(void**)&pPlayer))
	{
	    pPlayer->AddAdviseSink(this);
	    pPlayer->Release();
	}
    }
}

/****************************************************************************
 *  ExampleClientAdviceSink::~ExampleClientAdviceSink        ref:  exadvsnk.h
 *
 *  Destructor
 */
ExampleClientAdviceSink::~ExampleClientAdviceSink(void)
{
    if (m_pRegistry)
    {
        m_pRegistry->Release();
        m_pRegistry = NULL;
    }

    if (m_pUnknown)
    {
        m_pUnknown->Release();
        m_pUnknown = NULL;
    }
}

// Zuo for test something
void SearchAllRegistry(IRMAPNRegistry* m_pRegistry, char* pszRegistryKey, FILE *fp)
{
    char pszSubRegistryKey[256];
    IRMAValues *pRegValues;
    char *pPropertyName;
    IRMABuffer *pPropertyValue;
    ULONG32 myValue32;
    RMAPropType type;
    INT32 myIntValue;
    IRMABuffer *pmyStrValue;

	if (PNR_OK == m_pRegistry->GetPropListByName(pszRegistryKey, pRegValues))
    {
	    if (PNR_OK == pRegValues->GetFirstPropertyBuffer(pPropertyName, pPropertyValue))
        {
            strcpy(pszSubRegistryKey, pPropertyName);
            SearchAllRegistry(m_pRegistry, pszSubRegistryKey, fp);
            while (PNR_OK == pRegValues->GetNextPropertyBuffer(pPropertyName, pPropertyValue))
            {
                strcpy(pszSubRegistryKey, pPropertyName);
                SearchAllRegistry(m_pRegistry, pszSubRegistryKey, fp);
            }
        }
	    if (PNR_OK == pRegValues->GetFirstPropertyCString(pPropertyName, pPropertyValue))
        {
            strcpy(pszSubRegistryKey, pPropertyName);
            SearchAllRegistry(m_pRegistry, pszSubRegistryKey, fp);
            while (PNR_OK == pRegValues->GetNextPropertyCString(pPropertyName, pPropertyValue))
            {
                strcpy(pszSubRegistryKey, pPropertyName);
                SearchAllRegistry(m_pRegistry, pszSubRegistryKey, fp);
            }
        }
	    if (PNR_OK == pRegValues->GetFirstPropertyULONG32(pPropertyName, myValue32))
        {
            strcpy(pszSubRegistryKey, pPropertyName);
            type = m_pRegistry->GetTypeByName(pPropertyName);
            fprintf(fp, "%d --> %s\n", (int)type, pPropertyName);
            if (type == PT_COMPOSITE)
                SearchAllRegistry(m_pRegistry, pszSubRegistryKey, fp);
            else if (type == PT_INTEGER)
            {
                if (PNR_OK == m_pRegistry->GetIntByName(pPropertyName, myIntValue))
                    fprintf(fp, "  --> %d\n", (int)myIntValue);
            }
            else if (type == PT_STRING)
            {
                if (PNR_OK == m_pRegistry->GetStrByName(pPropertyName, pmyStrValue))
                    fprintf(fp, "  --> %s\n", (char *)pmyStrValue->GetBuffer());
            }
            while (PNR_OK == pRegValues->GetNextPropertyULONG32(pPropertyName, myValue32))
            {
                strcpy(pszSubRegistryKey, pPropertyName);
                type = m_pRegistry->GetTypeByName(pPropertyName);
                fprintf(fp, "%d --> %s\n", (int)type, pPropertyName);
                if (type == PT_COMPOSITE)
                    SearchAllRegistry(m_pRegistry, pszSubRegistryKey, fp);
                else if (type == PT_INTEGER)
                {
                    if (PNR_OK == m_pRegistry->GetIntByName(pPropertyName, myIntValue))
                        fprintf(fp, "  --> %d\n", (int)myIntValue);
                }
                else if (type == PT_STRING)
                {
                    if (PNR_OK == m_pRegistry->GetStrByName(pPropertyName, pmyStrValue))
                        fprintf(fp, "  --> %s\n", (char *)pmyStrValue->GetBuffer());
                }
            }
        }
    }
}

// Zuo for test something
int first = 1;

void SearchAllRegistryOfRoot(IRMAPNRegistry* m_pRegistry)
{
    char pszSubRegistryKey[256];
    IRMAValues *pRegValues;
    char *pPropertyName;
    IRMABuffer *pPropertyValue;
    ULONG32 myValue32;
    FILE *fp;

    fp = fopen("c:\\a.txt", "w");
	if (PNR_OK == m_pRegistry->GetPropListOfRoot(pRegValues))
    {
	    if (PNR_OK == pRegValues->GetFirstPropertyBuffer(pPropertyName, pPropertyValue))
        {
            strcpy(pszSubRegistryKey, pPropertyName);
            SearchAllRegistry(m_pRegistry, pszSubRegistryKey, fp);
            while (PNR_OK == pRegValues->GetNextPropertyBuffer(pPropertyName, pPropertyValue))
            {
                strcpy(pszSubRegistryKey, pPropertyName);
                SearchAllRegistry(m_pRegistry, pszSubRegistryKey, fp);
            }
        }
	    if (PNR_OK == pRegValues->GetFirstPropertyCString(pPropertyName, pPropertyValue))
        {
            strcpy(pszSubRegistryKey, pPropertyName);
            SearchAllRegistry(m_pRegistry, pszSubRegistryKey, fp);
            while (PNR_OK == pRegValues->GetNextPropertyCString(pPropertyName, pPropertyValue))
            {
                strcpy(pszSubRegistryKey, pPropertyName);
                SearchAllRegistry(m_pRegistry, pszSubRegistryKey, fp);
            }
        }
	    if (PNR_OK == pRegValues->GetFirstPropertyULONG32(pPropertyName, myValue32))
        {
            strcpy(pszSubRegistryKey, pPropertyName);
            SearchAllRegistry(m_pRegistry, pszSubRegistryKey, fp);
            while (PNR_OK == pRegValues->GetNextPropertyULONG32(pPropertyName, myValue32))
            {
                strcpy(pszSubRegistryKey, pPropertyName);
                SearchAllRegistry(m_pRegistry, pszSubRegistryKey, fp);
            }
        }
    }
    fclose(fp);
}

/****************************************************************************
 *  ExampleClientAdviceSink::GetRegistr       ref:  exadvsnk.h
 *
 *  return IRMARegistry
 */
STDMETHODIMP ExampleClientAdviceSink::OnVideoStatisticsOut(char* pszRegistryKey)
{
	
	//LARGE_INTEGER  lpPerformanceCount, lpPerformanceCount0;
	char    szRegistryValue[MAX_DISPLAY_NAME] = {0};
    INT32   lValue = 0;
    static char szVideoCodecName[64];
   // QueryPerformanceCounter(&lpPerformanceCount0);

// Zuo for test something
//    if (first)
//    {
//        SearchAllRegistryOfRoot(m_pRegistry);
//        first = 0;
//    }

	globalData.AverageBandWidth = GetIntValue("AverageBandWidth", pszRegistryKey);
	globalData.AverageLatency   = GetIntValue("AverageLatency", pszRegistryKey);
	globalData.CurrentBandWidth = GetIntValue("CurrentBandWidth", pszRegistryKey);
	globalData.TotalBandWidth  += globalData.CurrentBandWidth;
	globalData.CodedBandWidth	= GetIntValue("ClipBandWidth", pszRegistryKey);
	
	sprintf(szRegistryValue, "%s.Renderer", pszRegistryKey);
    globalData.CodedFrameRate	= atof(GetStrValue("CodecRate", szRegistryValue));
	globalData.CurrentFrameRate = atof(GetStrValue("CurrentFrameRate", szRegistryValue));
	globalData.FramesDropped	= GetIntValue("FramesDropped", szRegistryValue);
    globalData.FramesLost		= GetIntValue("FramesLost", szRegistryValue);
    globalData.CpuUsage         = theSysStatus.GetCpuUsage();

    // get the video stream codec name
    if (globalData.VideoCodecName == NULL)
    {
        char *pcodecname = GetStrValue("CodecName", szRegistryValue);
        if (strcmp(pcodecname, "-1") != 0)
        {
            strncpy(szVideoCodecName, pcodecname, 60);
            globalData.VideoCodecName = szVideoCodecName;
        }
    }

    globalData.NumOfPeriod      = 0;
    globalData.AverageFrameRate = 0;
    globalData.CurrentJitter    = -1;
    globalData.AverageJitter    = -1;

    if(m_RawData.num_total > 0)
	{
        globalData.NumOfPeriod   = m_RawData.num_one_second;
//        if (m_RawData.num_one_second > 0)
//            memcpy(globalData.intervals, m_RawData.intervals, sizeof(double)*globalData.NumOfPeriod);

        globalData.AverageFrameRate = m_RawData.num_total / m_RawData.sum_total * 1000;

        double frameInterval;

        if (m_RawData.num_one_second > 0)
        {
            frameInterval = m_RawData.sum_one_second / m_RawData.num_one_second;
            globalData.CurrentJitter = sqrt(m_RawData.sqr_one_second / m_RawData.num_one_second - frameInterval * frameInterval);
            if (globalData.MaxJitter < globalData.CurrentJitter)
                globalData.MaxJitter = globalData.CurrentJitter;
        }

		frameInterval = m_RawData.sum_total / m_RawData.num_total;
		globalData.AverageJitter = sqrt(m_RawData.sqr_total / m_RawData.num_total - frameInterval * frameInterval);

        m_RawData.sqr_one_second = 0;
		m_RawData.sum_one_second = 0;
		m_RawData.num_one_second = 0;
		
		/*if(time_minutes % 600 == 0)
		{
			VQJitter m_Jitter;
			frameInterval = m_RawData.sum_one_minute / m_RawData.num_one_minute;

			m_Jitter.CurrentJitter = m_RawData.sqr_one_minute / m_RawData.num_one_minute
								   + frameInterval * frameInterval
								   - 2 * m_RawData.sum_one_minute * frameInterval / m_RawData.num_one_minute;
   			m_Jitter.CurrentJitter = sqrt(globalData.CurrentJitter);
			m_Jitter.AverageJitter = globalData.AverageJitter;
			
			m_RawData.sqr_one_minute = 0;
			m_RawData.sum_one_minute = 0;
			m_RawData.num_one_minute = 0;

			WPARAM wParam = CVQ_DATA_ON_MINUTE;
			LPARAM lParam = (long)&m_Jitter;
			PostMessage(topWnd, WM_VQACTION, wParam, lParam);
		}*/
		
	}
	WPARAM wParam = CVQ_DATA_ON_STATISTICS;
	LPARAM lParam = (long) &globalData;
	// 	SendNotifyMessage(HWND_BROADCAST, WM_VQACTION, wParam, lParam);
	PostMessage(topWnd, WM_VQACTION, wParam, lParam);
	//QueryPerformanceCounter(&lpPerformanceCount);

	return PNR_OK;
}

STDMETHODIMP ExampleClientAdviceSink::GetIntValue(char* mesurement, char* pszRegistryKey)
{
	INT32 lValue = 0;
	char  szRegistryValue[MAX_DISPLAY_NAME] = {0};
    sprintf(szRegistryValue, "%s.%s", pszRegistryKey, mesurement);
	if(PNR_OK == m_pRegistry->GetIntByName(szRegistryValue, lValue))
		return lValue;
	return -1;
}
char* ExampleClientAdviceSink::GetStrValue(char* mesurement, char* pszRegistryKey)
{
	unsigned char* sValue = 0;
	IRMABuffer *pValue;
	char szRegistryValue[MAX_DISPLAY_NAME] = {0};
    sprintf(szRegistryValue, "%s.%s", pszRegistryKey, mesurement);
	if(PNR_OK == m_pRegistry->GetStrByName(szRegistryValue, pValue))
	{
		sValue = pValue->GetBuffer();
		return (char*)sValue;
	}
	return "-1";
}
/****************************************************************************
 *  ExampleClientAdviceSink::ShowMeTheStatistics             ref:  exadvsnk.h
 *
 */
void ExampleClientAdviceSink::ShowMeTheStatistics (char* pszRegistryKey)
{
    char    szRegistryValue[MAX_DISPLAY_NAME] = {0};
    INT32   lValue = 0;
    INT32   i = 0;
    INT32   lStatistics = 8;
    /*
    if (!bShowMeTheStatistics)
    {
	//return;
    }*/

    // collect statistic
    for (i = 0; i < lStatistics; i++)
    {
	switch (i)
	{
	case 0:
	    sprintf(szRegistryValue, "%s.Normal", pszRegistryKey);
	    break;
	case 1:
	    sprintf(szRegistryValue, "%s.Recovered", pszRegistryKey);
	    break;
	case 2:
	    sprintf(szRegistryValue, "%s.Received", pszRegistryKey);
	    break;
	case 3:
	    sprintf(szRegistryValue, "%s.Lost", pszRegistryKey);
	    break;
	case 4:
	    sprintf(szRegistryValue, "%s.Late", pszRegistryKey);
	    break;
	case 5:
	    sprintf(szRegistryValue, "%s.ClipBandwidth", pszRegistryKey);
	    break;
	case 6:
	    sprintf(szRegistryValue, "%s.AverageBandwidth", pszRegistryKey);
	    break;
	case 7:
	    sprintf(szRegistryValue, "%s.CurrentBandwidth", pszRegistryKey);
	    break;
	default:
	    break;
	}

	m_pRegistry->GetIntByName(szRegistryValue, lValue);
	fprintf(stdout, "%s = %ld\n", szRegistryValue, lValue);
    }
}


// IRMAClientAdviseSink Interface Methods

/****************************************************************************
 *  IRMAClientAdviseSink::OnPosLength                        ref:  rmaclsnk.h
 *
 *  Called to advise the client that the position or length of the
 *  current playback context has changed.
 */
STDMETHODIMP
ExampleClientAdviceSink::OnPosLength(UINT32	ulPosition, UINT32 ulLength)
{
    //fprintf(stdout, "OnPosLength(%ld, %ld)\n", ulPosition, ulLength);  
    // check our list of timers to see if we have to take a snap shot
    if(ulLength == 0)
		return PNR_OK;
	globalData.playTime = ulPosition;
	globalData.totalTime = ulLength;
	WPARAM wParam = CVQ_DATA_ON_POSITION;
	LPARAM lParam = (long)&globalData;
	PostMessage(topWnd, WM_VQACTION, wParam, lParam);
	
	if(ulPosition == 0)
		return PNR_OK;
	
	if(m_RawData.num_total < -5)
	{
		m_RawData.num_total = 0;
		time_minutes = 0;
	}
	else
        time_minutes ++;
	if(time_minutes % 10 == 0)
		OnStatistics();

    return PNR_OK;
}


/****************************************************************************
 *  IRMAClientAdviseSink::OnPresentationOpened               ref:  rmaclsnk.h
 *
 *  Called to advise the client a presentation has been opened.
 */
STDMETHODIMP
ExampleClientAdviceSink::OnPresentationOpened()
{
    //fprintf(stdout, "OnPresentationOpened()\n");
		m_RawData.num_one_second = 0;
		m_RawData.num_one_minute = 0;
		m_RawData.num_total = -1;
		m_RawData.sqr_one_second = 0;
		m_RawData.sqr_one_minute = 0;
		m_RawData.sqr_total = 0;
		m_RawData.sum_one_second = 0;
		m_RawData.sum_one_minute = 0;
		m_RawData.sum_total = 0;
		time_minutes = -1;
	
		globalData.Name = 0;
		globalData.CodedBandWidth = 0;
		globalData.AverageBandWidth = 0;
		globalData.TotalBandWidth = 0;
		globalData.CurrentBandWidth = 0;
		globalData.AverageLatency  = 0;
        globalData.TransportMode  = 2;
		globalData.CodedFrameRate = 0;
		globalData.AverageFrameRate = 0;
		globalData.CurrentFrameRate = 0;
		globalData.FramesDropped = 0;
		globalData.FramesLost = 0;
		globalData.AverageJitter = 0;
		globalData.CurrentJitter = 0;
		globalData.MaxJitter = 0;
        globalData.NumOfPeriod = 0;
        globalData.CpuUsage = 0.0;
        globalData.VideoCodecName = NULL;
        globalData.ServerInfo = NULL;

		WPARAM wParam = CVQ_DATA_ON_OPEN;
		LPARAM lParam = (long)&globalData;
		PostMessage(topWnd, WM_VQACTION, wParam, lParam);
		return PNR_OK;
}


/****************************************************************************
 *  IRMAClientAdviseSink::OnPresentationClosed               ref:  rmaclsnk.h
 *
 *  Called to advise the client a presentation has been closed.
 */
STDMETHODIMP
ExampleClientAdviceSink::OnPresentationClosed()
{
    //fprintf(stdout, "OnPresentationClosed()\n");
	WPARAM wParam = CVQ_DATA_ON_CLOSE;
	LPARAM lParam = 0;
	PostMessage(topWnd, WM_VQACTION, wParam, lParam);
    return PNR_OK;
}


/****************************************************************************
 *  IRMAClientAdviseSink::OnStatisticsChanged                ref:  rmaclsnk.h
 *
 *  Called to advise the client that the presentation statistics
 *  have changed. 
 */
STDMETHODIMP
ExampleClientAdviceSink::OnStatisticsChanged(void)
{
	//fprintf(stdout, "OnStatisticsChanged():\n");
	if( time_minutes < 0)
		OnStatistics();
	return PNR_OK;
}

STDMETHODIMP
ExampleClientAdviceSink::OnStatistics(void)
{
    UINT32  unPlayerIndex = 0;
    UINT32  unSourceIndex = 0;
    UINT32  unStreamIndex = 0;

    INT32   nRegistryValue = 0;
    IRMABuffer* pValue;
    char*   pszRegistryPrefix = "Statistics";
    char    szRegistryName[MAX_DISPLAY_NAME] = {0};

    static char szServerInfo[128];

    // display the content of whole statistic registry
    globalData.TotalBandWidth = 0;
    if (m_pRegistry)
    {
        // ok, let's start from the top (player)
        sprintf(szRegistryName, "%s.Player%ld", pszRegistryPrefix, unPlayerIndex);
        while (PT_COMPOSITE == m_pRegistry->GetTypeByName(szRegistryName))
        {
            // display player statistic
            //ShowMeTheStatistics(szRegistryName);
            sprintf(szRegistryName, "%s.Source%ld", szRegistryName, unSourceIndex);
            while (PT_COMPOSITE == m_pRegistry->GetTypeByName(szRegistryName))
            {
                char name[255];

                // get the transport protocol
                sprintf(name, "%s.TransportMode", szRegistryName);
                int thisTransportMode = 5;
                if (PNR_OK == m_pRegistry->GetStrByName(name, pValue))
                {
                    char* pTMode = (char*) (pValue->GetBuffer());
                    if (strcmp(pTMode, "TCP") == 0)
                        thisTransportMode = 1;
                    else if (strcmp(pTMode, "UDP") == 0)
                        thisTransportMode = 2;
                    else if (strcmp(pTMode, "RTSPvHTTP") == 0)
                        thisTransportMode = 3;
                    else if (strcmp(pTMode, "HTTP") == 0)
                        thisTransportMode = 4;
                }

                // get the media server information
                if (globalData.ServerInfo == NULL)
                {
                    sprintf(name, "%s.ServerInfo", szRegistryName);
                    if (PNR_OK == m_pRegistry->GetStrByName(name, pValue))
                    {
                        strncpy(szServerInfo, (char*)(pValue->GetBuffer()), 120);
                        globalData.ServerInfo = szServerInfo;
                    }
                }

                // display source statistic
                //ShowMeTheStatistics(szRegistryName);
                BOOL bActiveSource = FALSE;
                sprintf(szRegistryName, "%s.Stream%ld", szRegistryName, unStreamIndex);
                while (PT_COMPOSITE == m_pRegistry->GetTypeByName(szRegistryName))
                {
                    // display stream statistic
                    //ShowMeTheStatistics(szRegistryName);

                    char szRegistryValue[MAX_DISPLAY_NAME] = {0};
                    sprintf(szRegistryValue, "%s.Renderer", szRegistryName);
                    strcpy(name, szRegistryValue);
                    strcat(name, ".name");
                    if(PNR_OK == m_pRegistry->GetStrByName(name, pValue))
                    {
                        char* pname = (char*)(pValue->GetBuffer());
                        //name = pname;
                        if(pname[4] != 'V')
                        {
                            INT32 lValue = 0;
                            sprintf(name, "%s.CurrentBandWidth", szRegistryName);
                            if(PNR_OK == m_pRegistry->GetIntByName(name, lValue)) 
                            globalData.TotalBandWidth += lValue;
                        }
                        else 
                        {
                            globalData.Name = pname;
                            OnVideoStatisticsOut(szRegistryName);
                        }
                        bActiveSource = TRUE;
                    }

                    //if (bShowMeTheStatistics)
                    //    ShowMeTheStatistics(szRegistryName);
                    unStreamIndex++;
                    //CompleteStaticticas(szRegistryName);
                    sprintf(szRegistryName, "%s.Player%ld.Source%ld.Stream%ld", 
                    pszRegistryPrefix, unPlayerIndex, unSourceIndex, unStreamIndex);
                }
                if (bActiveSource)
                    globalData.TransportMode = thisTransportMode;
                unSourceIndex++;
                sprintf(szRegistryName, "%s.Player%ld.Source%ld",
                pszRegistryPrefix, unPlayerIndex, unSourceIndex);
            }
            unPlayerIndex++;
            sprintf(szRegistryName, "%s.Player%ld", pszRegistryPrefix, unPlayerIndex);
        }
    }

    return PNR_OK;
}

STDMETHODIMP
ExampleClientAdviceSink::CompleteStaticticas(char* szRegistryName)
{
		
	char registryName[MAX_DISPLAY_NAME] = {0};
	INT32 lValue = 0;
	IRMABuffer * nameBuffer;
	UCHAR * regName;

	sprintf(registryName, "%s", szRegistryName);
	int registryCount = m_pRegistry->GetNumPropsByName(registryName);
	int ID = m_pRegistry->GetId(registryName)+1;
	registryCount += ID+1;
	//if(PNR_OK==m_pRegistry->GetPropListByName(registryName, pValues))
	for(int i=ID; i<registryCount; i++)
	
	{	if(PNR_OK == m_pRegistry->GetPropName(i, nameBuffer))
		{
			regName = nameBuffer->GetBuffer();
			if(PNR_OK == m_pRegistry->GetStrById(i, nameBuffer))
				fprintf(stdout, "%s, %d = %s\n", regName, i,nameBuffer->GetBuffer());
			else if(PNR_OK == m_pRegistry->GetIntById(i, lValue)) 
				fprintf(stdout, "%s, %d= %d\n", regName, i, lValue);
		}//*/
	}
	return PNR_OK;
}
/****************************************************************************
 *  IRMAClientAdviseSink::OnPreSeek                          ref:  rmaclsnk.h
 *
 *  Called by client engine to inform the client that a seek is
 *  about to occur. The render is informed the last time for the 
 *  stream's time line before the seek, as well as the first new
 *  time for the stream's time line after the seek will be completed.
 */
STDMETHODIMP
ExampleClientAdviceSink::OnPreSeek(	UINT32	ulOldTime,
						UINT32	ulNewTime)
{
    //fprintf(stdout, "OnPreSeek(%ld, %ld)\n", ulOldTime, ulNewTime);
    return PNR_OK;
}


/****************************************************************************
 *  IRMAClientAdviseSink::OnPostSeek                         ref:  rmaclsnk.h
 *
 *  Called by client engine to inform the client that a seek has
 *  just occured. The render is informed the last time for the 
 *  stream's time line before the seek, as well as the first new
 *  time for the stream's time line after the seek.
 */
STDMETHODIMP
ExampleClientAdviceSink::OnPostSeek(	UINT32	ulOldTime,
						UINT32	ulNewTime)
{
   // fprintf(stdout, "OnPostSeek(%ld, %ld)\n", ulOldTime, ulNewTime);
    return PNR_OK;
}


/****************************************************************************
 *  IRMAClientAdviseSink::OnStop                             ref:  rmaclsnk.h
 *
 *  Called by client engine to inform the client that a stop has
 *  just occured. 
 */
STDMETHODIMP
ExampleClientAdviceSink::OnStop(void)
{
    //fprintf(stdout, "OnStop()\n");
	return PNR_OK;
}


/****************************************************************************
 *  IRMAClientAdviseSink::OnPause                            ref:  rmaclsnk.h
 *
 *  Called by client engine to inform the client that a pause has
 *  just occured. The render is informed the last time for the 
 *  stream's time line before the pause.
 */
STDMETHODIMP
ExampleClientAdviceSink::OnPause(UINT32 ulTime)
{
    //fprintf(stdout, "OnPause(%ld)\n", ulTime);
    return PNR_OK;
}


/****************************************************************************
 *  IRMAClientAdviseSink::OnBegin                            ref:  rmaclsnk.h
 *
 *  Called by client engine to inform the client that a begin or
 *  resume has just occured. The render is informed the first time 
 *  for the stream's time line after the resume.
 */
STDMETHODIMP
ExampleClientAdviceSink::OnBegin(UINT32 ulTime)
{
    //fprintf(stdout, "OnBegin(%ld)\n", ulTime);
	time_minutes = -1;
	m_RawData.num_total = -1;

    WPARAM wParam = CVQ_DATA_ON_BEGIN;
	LPARAM lParam = 0;
	PostMessage(topWnd, WM_VQACTION, wParam, lParam);

    return PNR_OK;
}


/****************************************************************************
 *  IRMAClientAdviseSink::OnBuffering                        ref:  rmaclsnk.h
 *
 *  Called by client engine to inform the client that buffering
 *  of data is occuring. The render is informed of the reason for
 *  the buffering (start-up of stream, seek has occured, network
 *  congestion, etc.), as well as percentage complete of the 
 *  buffering process.
 */
STDMETHODIMP
ExampleClientAdviceSink::OnBuffering
(
    UINT32 ulFlags,
    UINT16 unPercentComplete
)
{
    /*if(unPercentComplete % 10 == 0)
		fprintf(stdout, "OnBuffering(%ld, %d)\n", ulFlags, unPercentComplete);
	if(ulFlags == 2)
	{
		fprintf(stdout, "ReBuffering(%d)\n", unPercentComplete);
	//	pPlayer->Stop();
	}*/
    WPARAM wParam = CVQ_DATA_ON_BUFFER;
	LPARAM lParam = unPercentComplete;
	if(ulFlags == 2)
		lParam = -2;
	PostMessage(topWnd, WM_VQACTION, wParam, lParam);

	return PNR_OK;
}


/****************************************************************************
 *  IRMAClientAdviseSink::OnContacting                       ref:  rmaclsnk.h
 *
 *  Called by client engine to inform the client is contacting hosts(s).
 */
STDMETHODIMP
ExampleClientAdviceSink::OnContacting(const char* pHostName)
{
    //fprintf(stdout, "OnContacting(\"%s\")\n", pHostName);
	WPARAM wParam = CVQ_DATA_ON_CONTACT;
	LPARAM lParam = 0;
	PostMessage(topWnd, WM_VQACTION, wParam, lParam);
    return PNR_OK;
}


// IUnknown COM Interface Methods

/****************************************************************************
 *  IUnknown::AddRef                                            ref:  pncom.h
 *
 *  This routine increases the object reference count in a thread safe
 *  manner. The reference count is used to manage the lifetime of an object.
 *  This method must be explicitly called by the user whenever a new
 *  reference to an object is used.
 */
STDMETHODIMP_(UINT32) ExampleClientAdviceSink::AddRef()
{
    return InterlockedIncrement(&m_lRefCount);
}


/****************************************************************************
 *  IUnknown::Release                                           ref:  pncom.h
 *
 *  This routine decreases the object reference count in a thread safe
 *  manner, and deletes the object if no more references to it exist. It must
 *  be called explicitly by the user whenever an object is no longer needed.
 */
STDMETHODIMP_(UINT32) ExampleClientAdviceSink::Release()
{
    if (InterlockedDecrement(&m_lRefCount) > 0)
    {
        return m_lRefCount;
    }

    delete this;
    return 0;
}


/****************************************************************************
 *  IUnknown::QueryInterface                                    ref:  pncom.h
 *
 *  This routine indicates which interfaces this object supports. If a given
 *  interface is supported, the object's reference count is incremented, and
 *  a reference to that interface is returned. Otherwise a NULL object and
 *  error code are returned. This method is called by other objects to
 *  discover the functionality of this object.
 */
STDMETHODIMP ExampleClientAdviceSink::QueryInterface(REFIID riid, void** ppvObj)
{
    if (IsEqualIID(riid, IID_IUnknown))
    {
	AddRef();
	*ppvObj = (IUnknown*)(IRMAClientAdviseSink*)this;
	return PNR_OK;
    }
    else if (IsEqualIID(riid, IID_IRMAClientAdviseSink))
    {
	AddRef();
	*ppvObj = (IRMAClientAdviseSink*)this;
	return PNR_OK;
    }

    *ppvObj = NULL;
    return PNR_NOINTERFACE;
}
