/**************************************************************************
**
** Copyright (C) Computer Science Department, Worcester Polytechnic Institute,
**                           All rights reserved.
**
** FILE NAME: RealData.h
**
** DESCRIPTION: this class defines the document for RealData 
**
** AUTHOR: Zheng Zuo/Yubing Wang        March-2001
**
/**************************************************************************/


// RealDataDoc.h : interface of the CRealDataDoc class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_REALDATADOC_H__707737C2_9458_4EB9_B2FD_D73E0CEF8834__INCLUDED_)
#define AFX_REALDATADOC_H__707737C2_9458_4EB9_B2FD_D73E0CEF8834__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "RealTraceData.h"

class CRealTreeView;
class CRealListView;

class CRealDataDoc : public CDocument
{
protected: // create from serialization only
	CRealDataDoc();
	DECLARE_DYNCREATE(CRealDataDoc)

// Attributes
public:

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CRealDataDoc)
	public:
	virtual BOOL OnNewDocument();
	virtual BOOL OnOpenDocument(LPCTSTR lpszPathName);
	virtual BOOL OnSaveDocument(LPCTSTR lpszPathName);
	virtual void Serialize(CArchive& ar);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CRealDataDoc();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CRealDataDoc)
	afx_msg void OnFromemail();
	afx_msg void OnDataNewfolder();
	afx_msg void OnDataAddfiles();
	afx_msg void OnCdfFrAll();
	afx_msg void OnCdfFrSelected();
	afx_msg void OnCdfBwAll();
	afx_msg void OnCdfBwSelected();
	afx_msg void OnCdfJitterAll();
	afx_msg void OnCdfJitterSelected();
	afx_msg void OnCount();
	afx_msg void OnExport();
	afx_msg void OnEditDelete();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

private:
    CRealTraceData *m_pRealTraceData;

public:
    CRealTraceData *GetRealTraceData();
    CString GetLogFileName(char *subject, BOOL &bFirstLog);

    CRealTreeView *GetTreeView();
    CRealListView *GetListView();
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_REALDATADOC_H__707737C2_9458_4EB9_B2FD_D73E0CEF8834__INCLUDED_)
